diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/udp-client.cc ns-3.44/src/applications/model/udp-client.cc
--- ns-3.43/src/applications/model/udp-client.cc	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/model/udp-client.cc	2025-03-09 16:55:49.347370900 -0700
@@ -6,13 +6,12 @@
  * Author: Amine Ismail <amine.ismail@sophia.inria.fr>
  *                      <amine.ismail@udcast.com>
  */
+
 #include "udp-client.h"
 
 #include "seq-ts-header.h"
 
-#include "ns3/inet-socket-address.h"
-#include "ns3/inet6-socket-address.h"
-#include "ns3/ipv4-address.h"
+#include "ns3/address-utils.h"
 #include "ns3/log.h"
 #include "ns3/nstime.h"
 #include "ns3/packet.h"
@@ -36,7 +35,7 @@
 {
     static TypeId tid =
         TypeId("ns3::UdpClient")
-            .SetParent<Application>()
+            .SetParent<SourceApplication>()
             .SetGroupName("Applications")
             .AddConstructor<UdpClient>()
             .AddAttribute(
@@ -47,25 +46,27 @@
                 MakeUintegerChecker<uint32_t>())
             .AddAttribute("Interval",
                           "The time to wait between packets",
-                          TimeValue(Seconds(1.0)),
+                          TimeValue(Seconds(1)),
                           MakeTimeAccessor(&UdpClient::m_interval),
                           MakeTimeChecker())
             .AddAttribute("RemoteAddress",
                           "The destination Address of the outbound packets",
                           AddressValue(),
-                          MakeAddressAccessor(&UdpClient::m_peerAddress),
-                          MakeAddressChecker())
+                          MakeAddressAccessor(
+                              (void(UdpClient::*)(const Address&)) &
+                                  UdpClient::SetRemote, // this is needed to indicate which version
+                                                        // of the function overload to use
+                              &UdpClient::GetRemote),
+                          MakeAddressChecker(),
+                          TypeId::SupportLevel::DEPRECATED,
+                          "Replaced by Remote in ns-3.44.")
             .AddAttribute("RemotePort",
                           "The destination port of the outbound packets",
-                          UintegerValue(100),
-                          MakeUintegerAccessor(&UdpClient::m_peerPort),
-                          MakeUintegerChecker<uint16_t>())
-            .AddAttribute("Tos",
-                          "The Type of Service used to send IPv4 packets. "
-                          "All 8 bits of the TOS byte are set (including ECN bits).",
-                          UintegerValue(0),
-                          MakeUintegerAccessor(&UdpClient::m_tos),
-                          MakeUintegerChecker<uint8_t>())
+                          UintegerValue(UdpClient::DEFAULT_PORT),
+                          MakeUintegerAccessor(&UdpClient::SetPort, &UdpClient::GetPort),
+                          MakeUintegerChecker<uint16_t>(),
+                          TypeId::SupportLevel::DEPRECATED,
+                          "Replaced by Remote in ns-3.44.")
             .AddAttribute("PacketSize",
                           "Size of packets generated. The minimum packet size is 12 bytes which is "
                           "the size of the header carrying the sequence number and the time stamp.",
@@ -84,12 +85,13 @@
 }
 
 UdpClient::UdpClient()
+    : m_sent{0},
+      m_totalTx{0},
+      m_socket{nullptr},
+      m_peerPort{},
+      m_sendEvent{}
 {
     NS_LOG_FUNCTION(this);
-    m_sent = 0;
-    m_totalTx = 0;
-    m_socket = nullptr;
-    m_sendEvent = EventId();
 }
 
 UdpClient::~UdpClient()
@@ -98,18 +100,65 @@
 }
 
 void
-UdpClient::SetRemote(Address ip, uint16_t port)
+UdpClient::SetRemote(const Address& ip, uint16_t port)
 {
     NS_LOG_FUNCTION(this << ip << port);
-    m_peerAddress = ip;
-    m_peerPort = port;
+    SetRemote(ip);
+    SetPort(port);
 }
 
 void
-UdpClient::SetRemote(Address addr)
+UdpClient::SetRemote(const Address& addr)
 {
     NS_LOG_FUNCTION(this << addr);
-    m_peerAddress = addr;
+    if (!addr.IsInvalid())
+    {
+        m_peer = addr;
+        if (m_peerPort)
+        {
+            SetPort(*m_peerPort);
+        }
+    }
+}
+
+Address
+UdpClient::GetRemote() const
+{
+    return m_peer;
+}
+
+void
+UdpClient::SetPort(uint16_t port)
+{
+    NS_LOG_FUNCTION(this << port);
+    if (m_peer.IsInvalid())
+    {
+        // save for later
+        m_peerPort = port;
+        return;
+    }
+    if (Ipv4Address::IsMatchingType(m_peer) || Ipv6Address::IsMatchingType(m_peer))
+    {
+        m_peer = addressUtils::ConvertToSocketAddress(m_peer, port);
+    }
+}
+
+uint16_t
+UdpClient::GetPort() const
+{
+    if (m_peer.IsInvalid())
+    {
+        return m_peerPort.value_or(UdpClient::DEFAULT_PORT);
+    }
+    if (InetSocketAddress::IsMatchingType(m_peer))
+    {
+        return InetSocketAddress::ConvertFrom(m_peer).GetPort();
+    }
+    else if (Inet6SocketAddress::IsMatchingType(m_peer))
+    {
+        return Inet6SocketAddress::ConvertFrom(m_peer).GetPort();
+    }
+    return UdpClient::DEFAULT_PORT;
 }
 
 void
@@ -119,74 +168,65 @@
 
     if (!m_socket)
     {
-        TypeId tid = TypeId::LookupByName("ns3::UdpSocketFactory");
+        auto tid = TypeId::LookupByName("ns3::UdpSocketFactory");
         m_socket = Socket::CreateSocket(GetNode(), tid);
-        if (Ipv4Address::IsMatchingType(m_peerAddress))
+        NS_ABORT_MSG_IF(m_peer.IsInvalid(), "Remote address not properly set");
+        if (!m_local.IsInvalid())
         {
-            if (m_socket->Bind() == -1)
+            NS_ABORT_MSG_IF((Inet6SocketAddress::IsMatchingType(m_peer) &&
+                             InetSocketAddress::IsMatchingType(m_local)) ||
+                                (InetSocketAddress::IsMatchingType(m_peer) &&
+                                 Inet6SocketAddress::IsMatchingType(m_local)),
+                            "Incompatible peer and local address IP version");
+            if (m_socket->Bind(m_local) == -1)
             {
                 NS_FATAL_ERROR("Failed to bind socket");
             }
-            m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
-            m_socket->Connect(
-                InetSocketAddress(Ipv4Address::ConvertFrom(m_peerAddress), m_peerPort));
         }
-        else if (Ipv6Address::IsMatchingType(m_peerAddress))
+        else
         {
-            if (m_socket->Bind6() == -1)
+            if (InetSocketAddress::IsMatchingType(m_peer))
             {
-                NS_FATAL_ERROR("Failed to bind socket");
+                if (m_socket->Bind() == -1)
+                {
+                    NS_FATAL_ERROR("Failed to bind socket");
+                }
             }
-            m_socket->Connect(
-                Inet6SocketAddress(Ipv6Address::ConvertFrom(m_peerAddress), m_peerPort));
-        }
-        else if (InetSocketAddress::IsMatchingType(m_peerAddress))
-        {
-            if (m_socket->Bind() == -1)
+            else if (Inet6SocketAddress::IsMatchingType(m_peer))
             {
-                NS_FATAL_ERROR("Failed to bind socket");
+                if (m_socket->Bind6() == -1)
+                {
+                    NS_FATAL_ERROR("Failed to bind socket");
+                }
             }
-            m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
-            m_socket->Connect(m_peerAddress);
-        }
-        else if (Inet6SocketAddress::IsMatchingType(m_peerAddress))
-        {
-            if (m_socket->Bind6() == -1)
+            else
             {
-                NS_FATAL_ERROR("Failed to bind socket");
+                NS_ASSERT_MSG(false, "Incompatible address type: " << m_peer);
             }
-            m_socket->Connect(m_peerAddress);
-        }
-        else
-        {
-            NS_ASSERT_MSG(false, "Incompatible address type: " << m_peerAddress);
         }
+        m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
+        m_socket->Connect(m_peer);
+        m_socket->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
+        m_socket->SetAllowBroadcast(true);
     }
 
 #ifdef NS3_LOG_ENABLE
     std::stringstream peerAddressStringStream;
-    if (Ipv4Address::IsMatchingType(m_peerAddress))
-    {
-        peerAddressStringStream << Ipv4Address::ConvertFrom(m_peerAddress);
-    }
-    else if (Ipv6Address::IsMatchingType(m_peerAddress))
-    {
-        peerAddressStringStream << Ipv6Address::ConvertFrom(m_peerAddress);
-    }
-    else if (InetSocketAddress::IsMatchingType(m_peerAddress))
+    if (InetSocketAddress::IsMatchingType(m_peer))
     {
-        peerAddressStringStream << InetSocketAddress::ConvertFrom(m_peerAddress).GetIpv4();
+        peerAddressStringStream << InetSocketAddress::ConvertFrom(m_peer).GetIpv4() << ":"
+                                << InetSocketAddress::ConvertFrom(m_peer).GetPort();
+        ;
     }
-    else if (Inet6SocketAddress::IsMatchingType(m_peerAddress))
+    else if (Inet6SocketAddress::IsMatchingType(m_peer))
     {
-        peerAddressStringStream << Inet6SocketAddress::ConvertFrom(m_peerAddress).GetIpv6();
+        peerAddressStringStream << Inet6SocketAddress::ConvertFrom(m_peer).GetIpv6() << ":"
+                                << Inet6SocketAddress::ConvertFrom(m_peer).GetPort();
     }
-    m_peerAddressString = peerAddressStringStream.str();
+    m_peerString = peerAddressStringStream.str();
 #endif // NS3_LOG_ENABLE
 
-    m_socket->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
-    m_socket->SetAllowBroadcast(true);
-    m_sendEvent = Simulator::Schedule(Seconds(0.0), &UdpClient::Send, this);
+    m_sendEvent = Simulator::Schedule(Seconds(0), &UdpClient::Send, this);
 }
 
 void
@@ -209,7 +249,7 @@
     SeqTsHeader seqTs;
     seqTs.SetSeq(m_sent);
     NS_ABORT_IF(m_size < seqTs.GetSerializedSize());
-    Ptr<Packet> p = Create<Packet>(m_size - seqTs.GetSerializedSize());
+    auto p = Create<Packet>(m_size - seqTs.GetSerializedSize());
 
     // Trace before adding header, for consistency with PacketSink
     m_txTrace(p);
@@ -222,14 +262,14 @@
         ++m_sent;
         m_totalTx += p->GetSize();
 #ifdef NS3_LOG_ENABLE
-        NS_LOG_INFO("TraceDelay TX " << m_size << " bytes to " << m_peerAddressString << " Uid: "
+        NS_LOG_INFO("TraceDelay TX " << m_size << " bytes to " << m_peerString << " Uid: "
                                      << p->GetUid() << " Time: " << (Simulator::Now()).As(Time::S));
 #endif // NS3_LOG_ENABLE
     }
 #ifdef NS3_LOG_ENABLE
     else
     {
-        NS_LOG_INFO("Error while sending " << m_size << " bytes to " << m_peerAddressString);
+        NS_LOG_INFO("Error while sending " << m_size << " bytes to " << m_peerString);
     }
 #endif // NS3_LOG_ENABLE
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/udp-client.h ns-3.44/src/applications/model/udp-client.h
--- ns-3.43/src/applications/model/udp-client.h	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/model/udp-client.h	2025-03-09 16:55:49.347370900 -0700
@@ -11,11 +11,15 @@
 #ifndef UDP_CLIENT_H
 #define UDP_CLIENT_H
 
-#include "ns3/application.h"
+#include "source-application.h"
+
+#include "ns3/deprecated.h"
 #include "ns3/event-id.h"
 #include "ns3/ipv4-address.h"
 #include "ns3/ptr.h"
-#include <ns3/traced-callback.h>
+#include "ns3/traced-callback.h"
+
+#include <optional>
 
 namespace ns3
 {
@@ -24,39 +28,37 @@
 class Packet;
 
 /**
- * \ingroup udpclientserver
+ * @ingroup udpclientserver
  *
- * \brief A Udp client. Sends UDP packet carrying sequence number and time stamp
+ * @brief A Udp client. Sends UDP packet carrying sequence number and time stamp
  *  in their payloads
  *
  */
-class UdpClient : public Application
+class UdpClient : public SourceApplication
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
     UdpClient();
-
     ~UdpClient() override;
 
+    static constexpr uint16_t DEFAULT_PORT{100}; //!< default port
+
     /**
-     * \brief set the remote address and port
-     * \param ip remote IP address
-     * \param port remote port
-     */
-    void SetRemote(Address ip, uint16_t port);
-    /**
-     * \brief set the remote address
-     * \param addr remote address
+     * @brief set the remote address and port
+     * @param ip remote IP address
+     * @param port remote port
      */
-    void SetRemote(Address addr);
+    NS_DEPRECATED_3_44("Use SetRemote without port parameter instead")
+    void SetRemote(const Address& ip, uint16_t port);
+    void SetRemote(const Address& addr) override;
 
     /**
-     * \return the total bytes sent by this app
+     * @return the total bytes sent by this app
      */
     uint64_t GetTotalTx() const;
 
@@ -65,10 +67,28 @@
     void StopApplication() override;
 
     /**
-     * \brief Send a packet
+     * @brief Send a packet
      */
     void Send();
 
+    /**
+     * @brief Set the remote port (temporary function until deprecated attributes are removed)
+     * @param port remote port
+     */
+    void SetPort(uint16_t port);
+
+    /**
+     * @brief Get the remote port (temporary function until deprecated attributes are removed)
+     * @return the remote port
+     */
+    uint16_t GetPort() const;
+
+    /**
+     * @brief Get the remote address (temporary function until deprecated attributes are removed)
+     * @return the remote address
+     */
+    Address GetRemote() const;
+
     /// Traced Callback: transmitted packets.
     TracedCallback<Ptr<const Packet>> m_txTrace;
 
@@ -79,17 +99,15 @@
     Time m_interval;  //!< Packet inter-send time
     uint32_t m_size;  //!< Size of the sent packet (including the SeqTsHeader)
 
-    uint32_t m_sent;       //!< Counter for sent packets
-    uint64_t m_totalTx;    //!< Total bytes sent
-    Ptr<Socket> m_socket;  //!< Socket
-    Address m_peerAddress; //!< Remote peer address
-    uint16_t m_peerPort;   //!< Remote peer port
-    uint8_t m_tos;         //!< The packets Type of Service
-    EventId m_sendEvent;   //!< Event to send the next packet
+    uint32_t m_sent;                    //!< Counter for sent packets
+    uint64_t m_totalTx;                 //!< Total bytes sent
+    Ptr<Socket> m_socket;               //!< Socket
+    std::optional<uint16_t> m_peerPort; //!< Remote peer port (deprecated) // NS_DEPRECATED_3_44
+    EventId m_sendEvent;                //!< Event to send the next packet
 
 #ifdef NS3_LOG_ENABLE
-    std::string m_peerAddressString; //!< Remote peer address string
-#endif                               // NS3_LOG_ENABLE
+    std::string m_peerString; //!< Remote peer address string
+#endif                        // NS3_LOG_ENABLE
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/udp-echo-client.cc ns-3.44/src/applications/model/udp-echo-client.cc
--- ns-3.43/src/applications/model/udp-echo-client.cc	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/model/udp-echo-client.cc	2025-03-09 16:55:49.347370900 -0700
@@ -5,10 +5,7 @@
  */
 #include "udp-echo-client.h"
 
-#include "ns3/inet-socket-address.h"
-#include "ns3/inet6-socket-address.h"
-#include "ns3/ipv4-address.h"
-#include "ns3/ipv6-address.h"
+#include "ns3/address-utils.h"
 #include "ns3/log.h"
 #include "ns3/nstime.h"
 #include "ns3/packet.h"
@@ -30,7 +27,7 @@
 {
     static TypeId tid =
         TypeId("ns3::UdpEchoClient")
-            .SetParent<Application>()
+            .SetParent<SourceApplication>()
             .SetGroupName("Applications")
             .AddConstructor<UdpEchoClient>()
             .AddAttribute(
@@ -41,25 +38,28 @@
                 MakeUintegerChecker<uint32_t>())
             .AddAttribute("Interval",
                           "The time to wait between packets",
-                          TimeValue(Seconds(1.0)),
+                          TimeValue(Seconds(1)),
                           MakeTimeAccessor(&UdpEchoClient::m_interval),
                           MakeTimeChecker())
-            .AddAttribute("RemoteAddress",
-                          "The destination Address of the outbound packets",
-                          AddressValue(),
-                          MakeAddressAccessor(&UdpEchoClient::m_peerAddress),
-                          MakeAddressChecker())
+            .AddAttribute(
+                "RemoteAddress",
+                "The destination Address of the outbound packets",
+                AddressValue(),
+                MakeAddressAccessor(
+                    (void(UdpEchoClient::*)(const Address&)) &
+                        UdpEchoClient::SetRemote, // this is needed to indicate which version of the
+                                                  // function overload to use
+                    &UdpEchoClient::GetRemote),
+                MakeAddressChecker(),
+                TypeId::SupportLevel::DEPRECATED,
+                "Replaced by Remote in ns-3.44.")
             .AddAttribute("RemotePort",
                           "The destination port of the outbound packets",
-                          UintegerValue(0),
-                          MakeUintegerAccessor(&UdpEchoClient::m_peerPort),
-                          MakeUintegerChecker<uint16_t>())
-            .AddAttribute("Tos",
-                          "The Type of Service used to send IPv4 packets. "
-                          "All 8 bits of the TOS byte are set (including ECN bits).",
-                          UintegerValue(0),
-                          MakeUintegerAccessor(&UdpEchoClient::m_tos),
-                          MakeUintegerChecker<uint8_t>())
+                          UintegerValue(UdpEchoClient::DEFAULT_PORT),
+                          MakeUintegerAccessor(&UdpEchoClient::SetPort, &UdpEchoClient::GetPort),
+                          MakeUintegerChecker<uint16_t>(),
+                          TypeId::SupportLevel::DEPRECATED,
+                          "Replaced by Remote in ns-3.44.")
             .AddAttribute(
                 "PacketSize",
                 "Size of echo data in outbound packets",
@@ -86,13 +86,14 @@
 }
 
 UdpEchoClient::UdpEchoClient()
+    : m_dataSize{0},
+      m_data{nullptr},
+      m_sent{0},
+      m_socket{nullptr},
+      m_peerPort{},
+      m_sendEvent{}
 {
     NS_LOG_FUNCTION(this);
-    m_sent = 0;
-    m_socket = nullptr;
-    m_sendEvent = EventId();
-    m_data = nullptr;
-    m_dataSize = 0;
 }
 
 UdpEchoClient::~UdpEchoClient()
@@ -106,18 +107,65 @@
 }
 
 void
-UdpEchoClient::SetRemote(Address ip, uint16_t port)
+UdpEchoClient::SetRemote(const Address& ip, uint16_t port)
 {
     NS_LOG_FUNCTION(this << ip << port);
-    m_peerAddress = ip;
-    m_peerPort = port;
+    SetRemote(ip);
+    SetPort(port);
 }
 
 void
-UdpEchoClient::SetRemote(Address addr)
+UdpEchoClient::SetRemote(const Address& addr)
 {
     NS_LOG_FUNCTION(this << addr);
-    m_peerAddress = addr;
+    if (!addr.IsInvalid())
+    {
+        m_peer = addr;
+        if (m_peerPort)
+        {
+            SetPort(*m_peerPort);
+        }
+    }
+}
+
+Address
+UdpEchoClient::GetRemote() const
+{
+    return m_peer;
+}
+
+void
+UdpEchoClient::SetPort(uint16_t port)
+{
+    NS_LOG_FUNCTION(this << port);
+    if (m_peer.IsInvalid())
+    {
+        // save for later
+        m_peerPort = port;
+        return;
+    }
+    if (Ipv4Address::IsMatchingType(m_peer) || Ipv6Address::IsMatchingType(m_peer))
+    {
+        m_peer = addressUtils::ConvertToSocketAddress(m_peer, port);
+    }
+}
+
+uint16_t
+UdpEchoClient::GetPort() const
+{
+    if (m_peer.IsInvalid())
+    {
+        return m_peerPort.value_or(UdpEchoClient::DEFAULT_PORT);
+    }
+    if (InetSocketAddress::IsMatchingType(m_peer))
+    {
+        return InetSocketAddress::ConvertFrom(m_peer).GetPort();
+    }
+    else if (Inet6SocketAddress::IsMatchingType(m_peer))
+    {
+        return Inet6SocketAddress::ConvertFrom(m_peer).GetPort();
+    }
+    return UdpEchoClient::DEFAULT_PORT;
 }
 
 void
@@ -127,53 +175,48 @@
 
     if (!m_socket)
     {
-        TypeId tid = TypeId::LookupByName("ns3::UdpSocketFactory");
+        auto tid = TypeId::LookupByName("ns3::UdpSocketFactory");
         m_socket = Socket::CreateSocket(GetNode(), tid);
-        NS_ABORT_MSG_IF(m_peerAddress.IsInvalid(), "'RemoteAddress' attribute not properly set");
-        if (Ipv4Address::IsMatchingType(m_peerAddress))
+        NS_ABORT_MSG_IF(m_peer.IsInvalid(), "Remote address not properly set");
+        if (!m_local.IsInvalid())
         {
-            if (m_socket->Bind() == -1)
+            NS_ABORT_MSG_IF((Inet6SocketAddress::IsMatchingType(m_peer) &&
+                             InetSocketAddress::IsMatchingType(m_local)) ||
+                                (InetSocketAddress::IsMatchingType(m_peer) &&
+                                 Inet6SocketAddress::IsMatchingType(m_local)),
+                            "Incompatible peer and local address IP version");
+            if (m_socket->Bind(m_local) == -1)
             {
                 NS_FATAL_ERROR("Failed to bind socket");
             }
-            m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
-            m_socket->Connect(
-                InetSocketAddress(Ipv4Address::ConvertFrom(m_peerAddress), m_peerPort));
         }
-        else if (Ipv6Address::IsMatchingType(m_peerAddress))
+        else
         {
-            if (m_socket->Bind6() == -1)
+            if (InetSocketAddress::IsMatchingType(m_peer))
             {
-                NS_FATAL_ERROR("Failed to bind socket");
+                if (m_socket->Bind() == -1)
+                {
+                    NS_FATAL_ERROR("Failed to bind socket");
+                }
             }
-            m_socket->Connect(
-                Inet6SocketAddress(Ipv6Address::ConvertFrom(m_peerAddress), m_peerPort));
-        }
-        else if (InetSocketAddress::IsMatchingType(m_peerAddress))
-        {
-            if (m_socket->Bind() == -1)
+            else if (Inet6SocketAddress::IsMatchingType(m_peer))
             {
-                NS_FATAL_ERROR("Failed to bind socket");
+                if (m_socket->Bind6() == -1)
+                {
+                    NS_FATAL_ERROR("Failed to bind socket");
+                }
             }
-            m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
-            m_socket->Connect(m_peerAddress);
-        }
-        else if (Inet6SocketAddress::IsMatchingType(m_peerAddress))
-        {
-            if (m_socket->Bind6() == -1)
+            else
             {
-                NS_FATAL_ERROR("Failed to bind socket");
+                NS_ASSERT_MSG(false, "Incompatible address type: " << m_peer);
             }
-            m_socket->Connect(m_peerAddress);
-        }
-        else
-        {
-            NS_ASSERT_MSG(false, "Incompatible address type: " << m_peerAddress);
         }
+        m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
+        m_socket->Connect(m_peer);
+        m_socket->SetRecvCallback(MakeCallback(&UdpEchoClient::HandleRead, this));
+        m_socket->SetAllowBroadcast(true);
     }
 
-    m_socket->SetRecvCallback(MakeCallback(&UdpEchoClient::HandleRead, this));
-    m_socket->SetAllowBroadcast(true);
     ScheduleTransmit(Seconds(0.));
 }
 
@@ -339,48 +382,21 @@
     // call to the trace sinks before the packet is actually sent,
     // so that tags added to the packet can be sent as well
     m_txTrace(p);
-    if (Ipv4Address::IsMatchingType(m_peerAddress))
-    {
-        m_txTraceWithAddresses(
-            p,
-            localAddress,
-            InetSocketAddress(Ipv4Address::ConvertFrom(m_peerAddress), m_peerPort));
-    }
-    else if (Ipv6Address::IsMatchingType(m_peerAddress))
-    {
-        m_txTraceWithAddresses(
-            p,
-            localAddress,
-            Inet6SocketAddress(Ipv6Address::ConvertFrom(m_peerAddress), m_peerPort));
-    }
+    m_txTraceWithAddresses(p, localAddress, m_peer);
     m_socket->Send(p);
     ++m_sent;
 
-    if (Ipv4Address::IsMatchingType(m_peerAddress))
+    if (InetSocketAddress::IsMatchingType(m_peer))
     {
         NS_LOG_INFO("At time " << Simulator::Now().As(Time::S) << " client sent " << m_size
-                               << " bytes to " << Ipv4Address::ConvertFrom(m_peerAddress)
-                               << " port " << m_peerPort);
+                               << " bytes to " << InetSocketAddress::ConvertFrom(m_peer).GetIpv4()
+                               << " port " << InetSocketAddress::ConvertFrom(m_peer).GetPort());
     }
-    else if (Ipv6Address::IsMatchingType(m_peerAddress))
+    else if (Inet6SocketAddress::IsMatchingType(m_peer))
     {
         NS_LOG_INFO("At time " << Simulator::Now().As(Time::S) << " client sent " << m_size
-                               << " bytes to " << Ipv6Address::ConvertFrom(m_peerAddress)
-                               << " port " << m_peerPort);
-    }
-    else if (InetSocketAddress::IsMatchingType(m_peerAddress))
-    {
-        NS_LOG_INFO(
-            "At time " << Simulator::Now().As(Time::S) << " client sent " << m_size << " bytes to "
-                       << InetSocketAddress::ConvertFrom(m_peerAddress).GetIpv4() << " port "
-                       << InetSocketAddress::ConvertFrom(m_peerAddress).GetPort());
-    }
-    else if (Inet6SocketAddress::IsMatchingType(m_peerAddress))
-    {
-        NS_LOG_INFO(
-            "At time " << Simulator::Now().As(Time::S) << " client sent " << m_size << " bytes to "
-                       << Inet6SocketAddress::ConvertFrom(m_peerAddress).GetIpv6() << " port "
-                       << Inet6SocketAddress::ConvertFrom(m_peerAddress).GetPort());
+                               << " bytes to " << Inet6SocketAddress::ConvertFrom(m_peer).GetIpv6()
+                               << " port " << Inet6SocketAddress::ConvertFrom(m_peer).GetPort());
     }
 
     if (m_sent < m_count || m_count == 0)
@@ -393,10 +409,8 @@
 UdpEchoClient::HandleRead(Ptr<Socket> socket)
 {
     NS_LOG_FUNCTION(this << socket);
-    Ptr<Packet> packet;
     Address from;
-    Address localAddress;
-    while ((packet = socket->RecvFrom(from)))
+    while (auto packet = socket->RecvFrom(from))
     {
         if (InetSocketAddress::IsMatchingType(from))
         {
@@ -412,6 +426,7 @@
                                    << Inet6SocketAddress::ConvertFrom(from).GetIpv6() << " port "
                                    << Inet6SocketAddress::ConvertFrom(from).GetPort());
         }
+        Address localAddress;
         socket->GetSockName(localAddress);
         m_rxTrace(packet);
         m_rxTraceWithAddresses(packet, from, localAddress);
